bzoj2325 [ZJOI2011]道馆之战 树链剖分+DP+类线段树最大字段和

题目传送门

https://lydsy.com/JudgeOnline/problem.php?id=2325

题解

可以参考线段树动态维护最大子段和的做法。

对于线段树上每个节点 \(o\),维护 \(ls_{0/1}, rs_{0/1}, s_{0/1, 0/1}\) 分别表示从最左边的上面/下面的格子进入最多走的方块数量,从最右边的上面/下面的格子进入最多走的方块数量,从最左边的上面/下面到最右边的上面/下面的做多走的方块数量。

然后合并的时候也类似与线段树最大字段和。\(ls\) 的话保留左子区间的,再和左子区间的 \(s\) 与右子区间的 \(ls\) 配合的结果取最优;\(rs\) 类似;\(s\) 的话直接把左右子区间的两个对应合并起来就可以了。

树剖的时候可以剖出来两段从上到下的结果,然后把一段取反(左右颠倒)以后类似于上面的方法合并就可以了。



时间复杂度 \(O(m\log^2n)\)。

#include<bits/stdc++.h>

#define fec(i, x, y) (int i = head[x], y = g[i].to; i; i = g[i].ne, y = g[i].to)
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define File(x) freopen(#x".in", "r", stdin), freopen(#x".out", "w", stdout)
#define fi first
#define se second
#define pb push_back

template<typename A, typename B> inline char smax(A &a, const B &b) {return a < b ? a = b, 1 : 0;}
template<typename A, typename B> inline char smin(A &a, const B &b) {return b < a ? a = b, 1 : 0;}

typedef long long ll; typedef unsigned long long ull; typedef std::pair<int, int> pii;

template<typename I> inline void read(I &x) {
    int f = 0, c;
    while (!isdigit(c = getchar())) c == '-' ? f = 1 : 0;
    x = c & 15;
    while (isdigit(c = getchar())) x = (x << 1) + (x << 3) + (c & 15);
    f ? x = -x : 0;
}

#define lc o << 1
#define rc o << 1 | 1

const int N = 30000 + 7;
const int INF = 0x3f3f3f3f;

int n, m, dfc, cnt;
char a[N][3];
int dep[N], f[N], siz[N], son[N], dfn[N], pre[N], top[N];

struct Edge { int to, ne; } g[N << 1]; int head[N], tot;
inline void addedge(int x, int y) { g[++tot].to = y, g[tot].ne = head[x], head[x] = tot; }
inline void adde(int x, int y) { addedge(x, y), addedge(y, x); }

inline void dfs1(int x, int fa = 0) {
    dep[x] = dep[fa] + 1, f[x] = fa, siz[x] = 1;
    for fec(i, x, y) if (y != fa) dfs1(y, x), siz[x] += siz[y], siz[y] > siz[son[x]] && (son[x] = y);
}
inline void dfs2(int x, int pa) {
    dfn[x] = ++dfc, pre[dfc] = x, top[x] = pa;
    if (!son[x]) return; dfs2(son[x], pa);
    for fec(i, x, y) if (y != f[x] && y != son[x]) dfs2(y, y);
}

struct Node {
    int ls[2], rs[2], s[2][2];

    inline Node() { ls[0] = ls[1] = rs[0] = rs[1] = s[0][0] = s[0][1] = s[1][0] = s[1][1] = 0; }
    inline Node(char *a) {
        ls[0] = ls[1] = rs[0] = rs[1] = s[0][0] = s[0][1] = s[1][0] = s[1][1] = 0;
        if (a[0]) ++ls[0], ++rs[0], s[0][0] = 1; else s[0][1] = s[0][0] = s[1][0] = -INF;
        if (a[1]) ++ls[1], ++rs[1], s[1][1] = 1; else s[1][0] = s[1][1] = s[0][1] = -INF;
        if (s[0][1] != -INF) s[0][1] = s[1][0] = 2;
    }
} t[N << 2];

inline Node operator + (const Node &a, const Node &b) {
    Node ans;
    ans.ls[0] = std::max(a.ls[0], std::max(a.s[0][0] + b.ls[0], a.s[0][1] + b.ls[1]));
    ans.ls[1] = std::max(a.ls[1], std::max(a.s[1][0] + b.ls[0], a.s[1][1] + b.ls[1]));
    ans.rs[0] = std::max(b.rs[0], std::max(a.rs[0] + b.s[0][0], a.rs[1] + b.s[1][0]));
    ans.rs[1] = std::max(b.rs[1], std::max(a.rs[0] + b.s[0][1], a.rs[1] + b.s[1][1]));
    ans.s[0][0] = std::max(a.s[0][0] + b.s[0][0], a.s[0][1] + b.s[1][0]), smax(ans.s[0][0], -INF);
    ans.s[0][1] = std::max(a.s[0][0] + b.s[0][1], a.s[0][1] + b.s[1][1]), smax(ans.s[0][1], -INF);
    ans.s[1][0] = std::max(a.s[1][0] + b.s[0][0], a.s[1][1] + b.s[1][0]), smax(ans.s[1][0], -INF);
    ans.s[1][1] = std::max(a.s[1][0] + b.s[0][1], a.s[1][1] + b.s[1][1]), smax(ans.s[1][1], -INF);
    return ans;
}
inline Node operator - (const Node &a) {
    Node ans = a;
    std::swap(ans.ls[0], ans.rs[0]), std::swap(ans.ls[1], ans.rs[1]);
    std::swap(ans.s[0][1], ans.s[1][0]);
    return ans;
}

inline void build(int o, int L, int R) {
    if (L == R) return t[o] = Node(a[pre[L]]), (void)0;
    int M = (L + R) >> 1;
    build(lc, L, M), build(rc, M + 1, R);
    t[o] = t[lc] + t[rc];
    return;
}
inline void qupd(int o, int L, int R, int x) {
    if (L == R) return t[o] = Node(a[pre[L]]), (void)0;
    int M = (L + R) >> 1;
    if (x <= M) qupd(lc, L, M, x);
    else qupd(rc, M + 1, R, x);
    t[o] = t[lc] + t[rc];
}
inline Node qsum(int o, int L, int R, int l, int r) {
    if (l <= L && R <= r) return t[o];
    int M = (L + R) >> 1;
    if (r <= M) return qsum(lc, L, M, l, r);
    if (l > M) return qsum(rc, M + 1, R, l, r);
    return qsum(lc, L, M, l, r) + qsum(rc, M + 1, R, l, r);
}

inline int qry(int x, int y) {
    Node ans1, ans2;
    while (top[x] != top[y]) {
        if (dep[top[x]] > dep[top[y]]) {
            ans1 = qsum(1, 1, n, dfn[top[x]], dfn[x]) + ans1;
            x = f[top[x]];
        } else {
            ans2 = qsum(1, 1, n, dfn[top[y]], dfn[y]) + ans2;
            y = f[top[y]];
        }
    }
    if (dep[x] > dep[y]) ans1 = qsum(1, 1, n, dfn[y], dfn[x]) + ans1;
    else ans2 = qsum(1, 1, n, dfn[x], dfn[y]) + ans2;
    ans2 = -ans1 + ans2;
    return std::max(ans2.ls[0], ans2.ls[1]);
}

inline void work() {
    dfs1(1), dfs2(1, 1), build(1, 1, n);
    for (int i = 1; i <= m; ++i) {
        char opt[5];
        int x, y;
        scanf("%s", opt);
        if (*opt == 'Q') read(x), read(y), printf("%d\n", qry(x, y));
        else read(x), scanf("%s", a[x]), a[x][0] = a[x][0] == '.', a[x][1] = a[x][1] == '.', qupd(1, 1, n, dfn[x]);
    }
}

inline void init() {
    read(n), read(m);
    int x, y;
    for (int i = 1; i < n; ++i) read(x), read(y), adde(x, y);
    for (int i = 1; i <= n; ++i) scanf("%s", a[i]), a[i][0] = a[i][0] == '.', a[i][1] = a[i][1] == '.';
}

int main() {
#ifdef hzhkk
    freopen("hkk.in", "r", stdin);
#endif
    init();
    work();
    fclose(stdin), fclose(stdout);
    return 0;
}

原文地址:https://www.cnblogs.com/hankeke/p/bzoj2325.html

时间: 2024-10-12 00:33:24

bzoj2325 [ZJOI2011]道馆之战 树链剖分+DP+类线段树最大字段和的相关文章

BZOJ 2243:染色(树链剖分+区间合并线段树)

[SDOI2011]染色Description给定一棵有n个节点的无根树和m个操作,操作有2类:1.将节点a到节点b路径上所有点都染成颜色c:2.询问节点a到节点b路径上的颜色段数量(连续相同颜色被认为是同一段),如“112221”由3段组成:“11”.“222”和“1”.请你写一个程序依次完成这m个操作.Input第一行包含2个整数n和m,分别表示节点数和操作数:第二行包含n个正整数表示n个节点的初始颜色下面 行每行包含两个整数x和y,表示x和y之间有一条无向边.下面 行每行描述一个操作:“C

BZOJ 2243: [SDOI2011]染色 树链剖分 倍增lca 线段树

2243: [SDOI2011]染色 Time Limit: 20 Sec  Memory Limit: 256 MB 题目连接 http://www.lydsy.com/JudgeOnline/problem.php?id=2243 Description 给定一棵有n个节点的无根树和m个操作,操作有2类: 1.将节点a到节点b路径上所有点都染成颜色c: 2.询问节点a到节点b路径上的颜色段数量(连续相同颜色被认为是同一段),如“112221”由3段组成:“11”.“222”和“1”. 请你写

【BZOJ4515】游戏,树链剖分+永久化标记线段树维护线段信息(李超线段树)

Time:2016.05.10 Author:xiaoyimi 转载注明出处谢谢 传送门 思路: 李超线段树 一开始听faebdc讲,并没有听的很懂ww 后来找到良心博文啊有木有 折越 首先可以把修改转换一下,因为那个dis非常不爽.显然s~t的路径有s~lca和lca~t组成.令d[x]表示x的深度,对于s~lca上面的点,修改的值相当于a*(d[s]-d[x])+b=-a*d[x]+(b-a*d[s]),lca~t上面的点的值相当于a*(d[s]+d[x]-2*d[lca])+b=a*d[x

【树链剖分(区间线段树)】BZOJ4196-[NOI2015]软件包管理

[题目大意] 如果软件包A依赖软件包B,那么安装软件包A以前,必须先安装软件包B.同时,如果想要卸载软件包B,则必须卸载软件包A.而且,由于你之前的工作,除0号软件包以外,在你的管理器当中的软件包都会依赖一个且仅一个软件包,而0号软件包不依赖任何一个软件包.依赖关系不存在环.求出在安装和卸载某个软件包时,实际上会改变多少个软件包的安装状态(即安装操作会安装多少个未安装的软件包,或卸载操作会卸载多少个已安装的软件包.(注意,安装一个已安装的软件包,或卸载一个未安装的软件包,都不会改变任何软件包的安

【树链剖分】【线段树】bzoj3626 [LNOI2014]LCA

引用题解: http://blog.csdn.net/popoqqq/article/details/38823457 题目大意: 给出一个n个节点的有根树(编号为0到n-1,根节点为0).一个点的深度定义为这个节点到根的距离+1.设dep[i]表示点i的深度,LCA(i,j)表示i与j的最近公共祖先.有q次询问,每次询问给出l r z,求sigma_{l<=i<=r}dep[LCA(i,z)].(即,求在[l,r]区间内的每个节点i与z的最近公共祖先的深度之和) 这题看见了直接卡壳...然后

【块状树】【树链剖分】【线段树】bzoj3531 [Sdoi2014]旅行

离线后以宗教为第一关键字,操作时间为第二关键字排序. <法一>块状树,线下ac,线上tle…… #include<cstdio> #include<cmath> #include<algorithm> #include<cstring> #include<queue> using namespace std; queue<int>q; int f,c; inline void R(int &x){ c=0;f=1;

codeforces 343D Water Tree 树链剖分 dfs序 线段树 set

题目链接 这道题主要是要考虑到同一棵子树中dfs序是连续的 然后我就直接上树剖了... 1 #include<bits/stdc++.h> 2 using namespace std; 3 const int MAXN=600005; 4 5 struct Node 6 { 7 int l,r; 8 int value; 9 void init() 10 { 11 l=r=value=0; 12 } 13 }tree[4*MAXN]; 14 vector<int>nei[MAXN]

[GDOI2016] 疯狂动物园 [树链剖分+可持久化线段树]

题面 太长了,而且解释的不清楚,我来给个简化版的题意: 给定一棵$n$个点的数,每个点有点权,你需要实现以下$m$个操作 操作1,把$x$到$y$的路径上的所有点的权值都加上$delta$,并且更新一个版本 操作2,对于有向路径$(x,y)$上的点$a_i$,求下面的和值: $\sum_{i=1}^{len} a_i \sum_{j=1}^{len-i} j$ 操作3,回到第$i$个版本(但是下一次更新以后还是到总版本号+1的那个版本) 思路 这个题显然一眼就是树剖+可持久化数据结构啊 那么核心

【BZOJ3681】Arietta 树链剖分+可持久化线段树优化建图+网络流

[BZOJ3681]Arietta Description Arietta 的命运与她的妹妹不同,在她的妹妹已经走进学院的时候,她仍然留在山村中.但是她从未停止过和恋人 Velding 的书信往来.一天,她准备去探访他.对着窗外的阳光,临行前她再次弹起了琴.她的琴的发声十分特殊.让我们给一个形式化的定义吧.所有的 n 个音符形成一棵由音符 C ( 1 号节点) 构成的有根树,每一个音符有一个音高 Hi .Arietta 有 m 个力度,第 i 个力度能弹出 Di 节点的子树中,音高在 [Li,R